note file ERRCHK
note - automatically create g1(vars. to be linearised)
switch b10
  case 0: note standard multinomial
    set b15 1
    link -1 g1
    gset 0 g1 g9 g20
    gsize g20 b1
    switch b1
    case 0: say \nvariables in Group 9 must be explanatory variables\n
    wmsg "variables in group 9 must be explanatory variables"
          abort
    case  : note ok
          leave
    ends
  leave
  case 1: note ordered multinomial
          set b15 1
          link c178 g19
          link -1 g1
          gset 1 g1 g19 g1
          leave
ends

switch b15
  case 1:note ok
         leave
ends
note b6 = bottom level + 1
calc b6 = b15+1

note check variables in G9 are declared at bottom level when appropriate
calc b1= (-(b15+10))
link b1 g12
gset 1 g9 g12 g12
gsize g12 b1

switch b10
  case 0: note standard multinomial
switch b1
  case 0: leave
  case  : note error unless 2nd iteration & offsets
          say \nvariables in group 9 not declared at bottom level\n
          wmsg "variables in group 9 not declared at bottom level"
          abort
ends

gset 1 g1 g9 g1
gsize g9 b1
switch b1
  case 0: say \nGroup 9 must be set to the bottom level random variables\n
  wmsg "group 9 must be set to the bottom level random variables"
          abort
ends

link -3 g13
gset 0 g9 g13 g13
gsize g13 b1
switch b1
  case 0: note ok
          leave
  case  : say \nvariables random at bottom level must not be used elsewhere in the model\n
  wmsg "variables random at bottom level must not be used elsewhere"
          abort
ends
leave
case 1:note ordered multinomial
leave
ends      

gsize g11 b1
link -2 g12
switch b1
  case 0: leave
  case  : note subtract linear part of model from group1 & group2
          gset 1 g1 g11 g1
          gset 1 g12 g11 g12
          leave
ends

gsize g1 b18
switch b18
  case 0: say no non-linear component to mixed response model - check group 11\n
  wmsg "no non-linear component to mixed response model - check group 11"
  abort
ends

count g1[1] b18
switch b10
  case 0 : note multinomial logistic
           exist 'denom' b17
           switch b17
             case 0 : say denominator column called DENOM must be created\n
                      wmsg "denominator column called DENOM must be created"
                      abort
           ends
           count 'denom' b19
           calc b19=b18-b19
           switch b19
             case 0 : note ok
                      leave
             case   : say column length mismatch between DENOM and expl. variables\n
             wmsg "column length mismatch between DENOM and expl. variables"
                      abort
           ends
           leave

  case 1 : note ordered multinomial
           switch b20
             case 1 : note offset specified so check length
                      count 'offs' b19
                      calc b19=b18-b19
                      switch b19
                        case 0 : note ok
                                 leave
                        case   : say column length mismatch between OFFS and expl. variables\n
                        wmsg "column length mismatch between OFFS and expl. variables"
                                 abort
                      ends  
                      
           ends
           leave

  case : say \nb10 must be set to : 0=multinomial, 1=ordered multinomial\n
  wmsg "b10 must be set to :0=multinomial, 1=ordered nultinomial"
         abort
ends

switch b11
  case 1,2:note ok
         leave
  case : say \nb11 must be set to no more than 2=2nd order\n
  wmsg "b11 must be set to no more than 2=2nd order"
         abort
ends

switch b12
  case 0,1:note ok
         leave
  case : say \nb12 must be set to : 0=fixed part prediction, 1 fixed+residuals prediction\n
  wmsg "b12 must be set to : 0=fixed part prediction, 1 fixed+residuals prediction"
         abort
ends

switch b13
  case 0,1 : note ok
    leave
   case : say \n b13 must be set to: 0=logit, 1=loglog \n
   wmsg "b13 must be set to: 0=logit, 1=loglog"
    abort
ends
switch b14
  case 0,1:note ok
         leave
  case : say \nb14 must be set to : 0=distributional, 1=constrained\n
  wmsg "b14 must be set to: 0=distributional, 1=constrained"
         abort
ends

calc b6=3

switch b16
  case 0:note ok 
         leave

  case 1:note mixed model,mask is set to 1 if discrete, 0 if continuous
         gadd g9 'mask'
         calc 'mask'= abso( sign('mask') )
         calc 'denom'='denom'*'mask'
         chan 0 'denom' 1 'denom'
         leave
         gsize g11 b1
         switch b1
            case 0 : note no linear part to model
                     say Group 11 must contain linear part of mixed response model\n
                     wmsg "group 11 must contain linear part of mixed response model"
                     abort
         ends
         leave

  case : say \n b16 must be set to 0 uniform  or 1 mixed - response type\n
  wmsg "b16 must be set to 0 uniform or 1 mixed - response type"
         abort
ends
endo
