echo 0
note file PRE
note   user sets G9 to bottom level variables which model binomial/poisson
note   variation
note   user sets G11 to any variables that are not to be linearised
note   user sets G10 to any bottom level variables that are to have the linearising
note   transformation applied to them - ie bottom level extra binomial vars
note   macros set G1 fixed or random part variables to be linearised
note   macros set G12 to fixed part variables to be linearised
note   macros set b5 is resp col. number, b6 bottom level + 1
name c180 'H' C181 'F~(H)' C182 'H*' C183 'Pi' c184 'mask' c189 'Y-VAR' 
name c178 'P' c179 '-P' 
exist 'offs' b20
obey errchk.mc
yvar b5

NOTE                           GET H
NOTE----------------------------------------------------------------


itnum 0 b9
switch b9
  case 0: note 1st iteration
	  obey pre_0.mc
	  return
  case 1: note iter 1
	  calc g18=g12
	  pred g12 'H'
  case  : note otherwise
	  pred g12 'H'
	  switch b12
	    case 1 : note residual predictions required
		     obey predr1.mc
	  ends
ends
switch b20
  case 1 : note add offsets
	   calc 'H' = 'H' + 'offs'
ends
switch b16
  case 1: note mixed model
	  calc 'H'='H'*'mask'
ends


NOTE         GET FIRST DERRIVATIVE - F~(H) AND TRANSFORM DATA
NOTE----------------------------------------------------------------
switch b10
 case 0 : note 1st order multinomial
	  switch b13
	    case 0: note LOGIT
		   obey mnom_p.mc
		   obey mnom_f~.mc
		   leave
	    case 1:note C LOG-LOG
		   calc 'Pi'=1-expo(-expo('H'))
		   calc 'F~(H)'=(1-'Pi')*expo('H')
		   leave
	    case : note
		say \n only B13=0/logit, b13=1/log-log is available \n
		abort
	  ends
	  leave

 case 1 : note 1st order ordered multinomial
	  clrv 1
	  switch b13
	    case 0: note LOGIT
	       calc 'Pi'=1/(1+expo(-('H')))
	       calc 'F~(H)'='Pi'/(1+expo('H'))
	       leave        
	    case 1: note C log-log
	       calc 'Pi'=1-expo(-expo('H'))
	       calc 'F~(H)'=(1-'Pi')*expo('H')
	       leave
	  ends
	 leave
ends

gmult g1 'F~(H)'

NOTE               FORM "H*" = (X*)B or (X*)(B+U)
NOTE----------------------------------------------------------------

pred g12 'H*' 
note form residual predictions X*(B+U)
switch b12
  case 1: OBEY PREDR2.mc
ends

NOTE  TRANSFORM LEVEL BOTTOM LEVEL & SET DISTRIBUTIONAL CONSTRAINTS
NOTE----------------------------------------------------------------
switch b10
  case 0: note multinomial
	  switch b13
	  case 0,1: note LOGISTIC and LOG-LOG
		  calc 'P'=g9[1]*'Pi'/sqrt(2*'denom')
		  calc g9[1]=g9[1]*sqrt('Pi'/'denom')
		  calc '-P'=(-'P')
		  expl 1 'P' '-P'
		  fpar 0 'P' '-P'
		  sete 2 'P' '-P'
		  obey mnom_mix.mc
		  leave
	  case:
		say \n Use B13 = 0/Logit, 1/log-log only \n
		abort
	  ends
	  leave

  case 1: note ordered multinomial
	  switch b13
	     case 0,1: note LOGISTIC and LOGLOG
		    count 'H' b201
		    calc 'P'='Pi'/sqrt('denom')
		    calc '-P'=(1-'Pi')/sqrt('denom')
		    idco 2 b201
		    muls cb201 -2 'P' '-P' 'P'
		    expl 1 'p'
		    fpar 0 'p'
		    setd 2 'p'
		    obey mnom_mix.mc
		    leave
	     case : say \n use b13=0 logit\1 loglog \n
		    abort
	  ends
	  leave
ends

note b14 extra-distributional
switch b14
  case 0   : obey bvar.mc
	     leave
  case 1   : obey nobvar.mc
ends

NOTE                   TRANSFORM RESPONSE
NOTE------------------------------------------------------------

calc 'Y-VAR' = cb5
switch b20
  case 1: note offsets exist 
	  calc 'H*' = 'H*'
ends
calc  cb5 = cb5- ('Pi' - 'H*') 

NOTE                 ADD 2ND ORDER CORRECTIONS
NOTE------------------------------------------------------------
switch b11
  case 1: note remove offs
	  nlev b1
	  loop b2 2 b1
	  offs b2
	  endloop
	  leave
  case 2: obey order2a.mc
ends

NOTE                 DEAL WITH MIXED MODEL
NOTE------------------------------------------------------------

switch b16
  case 1 : note reset continous responses to original value, mask is set to
	   note 1 if discrete, 0 if continuous
	   calc cb5=cb5*'mask'
	   calc cb5=cb5+(1-'mask')*'Y-VAR'
	   leave
ends
endo
